#ifndef CMDSIRURI_H
#define CMDSIRURI_H

#include <iostream>

#include "Comanda.h"
#include "../Calcule/Exceptii.h"
#include "../util.h"
#include "../Calcule/siruri.h"

using namespace Calculator::Calcule;
namespace Calculator
{
     namespace UI
     {
         template<typename SirNumere, int MAX, int MIN=0>
         class CmdSiruri : public Comanda
         {
         private:
            SirNumere _sir;
         public:
            CmdSiruri(const string &nume) : Comanda(nume)
            {

            }
        void Execute()
            {
                cout << "Introduceti un numar intreg in intervalul ["
                    << MIN << ", " << MAX << "]." << endl;
                int n;
                cout << "Dati n = ";
                cin >> n;

                if (n < MIN || n > MAX)
                {
                    throw Calculator::Calcule::ParametruInAfaraIntervalului();
                }

                cout << endl << "Sirul " << Nume() << "[" << MIN << " - " << n << "]:\n" << _sir(n) << endl;
                 ::AsteaptaUser();
            }

         };




     }

}








#endif // CMDSIRURI_H
