#include "test.h"
#include "Calcule/combinatorial.h"
// Se adauga headerele pentru testarea fiecarei functionalitati in program
#include <iostream>
#include "util.h"
#include "Calcule/Exceptii.h"
#include "Calcule/Operatii.h"



#include "UI/CmdExit.h"
#include "UI/Meniu.h"
#include "UI/CmdOperatii.h"
#include "UI/MeniuOperatii.h"
#include "UI/MeniuPrincipal.h"
#include "UI/meniucombinatorial.h"
#include "UI/meniusiruri.h"
#include "UI/cmdcombinatorial.h"
#include "UI/cmdsiruri.h"
#include "Aplicatie.h"

//TODO: se adauga directivele include necesare





// regiune de include pentru testare
// poate contine orice directiva de using
using namespace Calculator;
using namespace Calculator::Calcule;
using namespace Calculator::UI;



void TestOperatii()
{
    int x = 10;
    int y = 5;

    int suma = Adunare(x, y);
    int diferenta = Scadere(x, y);
    int produs = Inmultire(x, y);
    int impartire = Impartire(x, y);


}


void TestExceptiiOperatii()
{
    // testarea erorilor
    try
    {
        Impartire(5, 0);
    }
    catch(ImpartireLaZero &)
    {
        cout << "Impartire la zero\n";
    }
}


void TestCmdOperatii()
{
    CmdOperatii<Adunare> op("+");
    op.Execute();
}


void TestMeniuOperatii()
{
    MeniuOperatii meniu;
    meniu.Execute();
}


void TestAplicatie()
{
    Aplicatie app;
    app.Run();
}


// TODO: se implementeaza functii de test pentru fiecare functionalitate adaugata
void TestCombinatorial()
{
    int a41 = Aranjamente(4,1);
    int a42 = Aranjamente(4,2);
    int a43 = Aranjamente(4,3);
    int c41 = Combinari(4,1);
    int c42 = Combinari(4,2);
    int c43 = Combinari(4,3);
}




void Test()
{
    TestOperatii();
    TestCombinatorial();

    // TestExceptiiOperatii();

    TestCmdOperatii();

    TestMeniuOperatii();

    TestAplicatie();


    //TODO: se atauga apelurile de test si se comenteaza cele anterioare
}
