#include "combinatorial.h"
#include "Exceptii.h"

namespace Calculator
{
    namespace Calcule
    {

        int Factorial(int n)
        {

            if(n > 12 || n < 0)
            {
                throw InvalidN();
            }
            int result =1;
            for(int i = 1; i <= n; i++)
            {
                result *=i;
            }
            return result;
        }
        int Aranjamente(int n, int k)
        {
            if(k < 0 || k > n)
            {
                throw InvalidK();
            }
            return Factorial(n)/Factorial(n-k);
        }

        int Combinari(int n, int k)
        {
            return Aranjamente(n, k)/Factorial(k);
        }


    }


}
