#ifndef CMDCOMBINATORIAL_H
#define CMDCOMBINATORIAL_H
#include <iostream>
#include "Comanda.h"
#include "../Calcule/Exceptii.h"
#include "../util.h"
#include "../Calcule/combinatorial.h"
using namespace Calculator::Calcule;
namespace Calculator
{
    namespace UI
    {
       template <int Operatie(int), int MAX, int MIN = 0>
       class CmdCombinatorial1 : public Comanda
       {
       public:
        CmdCombinatorial1(const string &nume): Comanda(nume)
        {

        }
        ~CmdCombinatorial1()
        {

        }
        void Execute()
        {
            cout << "Introduceti un numar intreg in intervalul ["
            << MIN << "," << "]. " << endl;
            int n;
            cout << "Dati n = ";
            cin >> n;
            if (n < MIN || n > MAX)
                {
                    throw InvalidN();
                }
            cout << Nume() << "(" << n << ") " << Operatie(n) << endl;
            ::AsteaptaUser();
        }

       } ;

        template <int Operatie(int, int), int MAX, int MIN = 0>
        class CmdCombinatorial2 : public Comanda
        {
             void Test(int param, Exceptie e)
            {
                if (param < MIN || param > MAX)
                {
                    throw e;
                }
            }
        public:
            CmdCombinatorial2(const string &nume): Comanda(nume)
            {

            }
            ~CmdCombinatorial2()
            {

            }
            void Execute()
            {
                cout << "Introduceti doua numere intregi(n, k, n > k), in intervalul ["
                << MIN << ", " << MAX << "]. " << endl;
                int n, k;
                cout << "Dati n = ";
                cin >> n;
                Test(n, InvalidN());
                cout << "Dati k = ";
                cin >> k;
                Test(k, InvalidK());
                cout << endl << Nume() << "(" << n << ", " << k << ") = " << Operatie(n, k) << endl;
                 ::AsteaptaUser();
            }



        };





    }


}














#endif // CMDCOMBINATORIAL_H
